<?php
/*
Simple:Press
Topic Subscriptions Plugin Support Routines
$LastChangedDate: 2013-08-23 12:55:44 -0700 (Fri, 23 Aug 2013) $
$Rev: 10569 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_custom_profile_do_load_meta($list) {
    $cfields = sp_custom_profile_fields_get_data();
    if (!empty($cfields)) {
        foreach ($cfields as $c) {
        	$list[$c['slug']] = ($c['type'] == 'textarea') ? 'text' : 'title';
        }
    }
    return $list;
}

function sp_custom_profile_uninstall_option_links($actionlink, $plugin) {
	if ($plugin == 'custom-profile-fields/sp-custom-profile-fields-plugin.php') {
        $url = SFADMINPLUGINS.'&amp;action=uninstall&amp;plugin='.$plugin.'&amp;sfnonce='.wp_create_nonce('forum-adminform_plugins');
        $actionlink.= "&nbsp;&nbsp;<a href='$url' title='".__('Uninstall this plugin', 'cpf')."'>".__('Uninstall', 'cpf').'</a>';
        $url = SFADMINPROFILE.'&amp;tab=plugin&amp;admin=sp_custom_profile_fields_admin&amp;save=sp_custom_profile_fields_update&amp;form=1';
        $actionlink.= "&nbsp;&nbsp;<a href='$url' title='".__('Options', 'cpf')."'>".__('Options', 'cpf').'</a>';
    }
	return $actionlink;
}

function sp_custom_profile_fields_get_data() {
	global $spGlobals;
	if(isset($spGlobals['customProfileFields']['data']) && !empty($spGlobals['customProfileFields']['data'])) return $spGlobals['customProfileFields']['data'];
}

function sp_custom_profile_fields_menu_select($tabs, $form) {
	echo '<select class="sfacontrol" name="cfieldform[]">';
	$selected = ($form == 'none') ? ' selected="selected"' : '';
	echo "<option value='none'$selected'>".__("Don't display", 'cpf').'</option>';
	if ($tabs) {
		foreach ($tabs as $tab) {
			if ($tab['menus']) {
				foreach ($tab['menus'] as $menu) {
					$selected = ($form == $menu['slug']) ? ' selected="selected"' : '';
					echo "<option value='".esc_attr($menu['slug'])."'$selected>".$menu['name'].'</option>';
				}
			}

		}
	}
	echo '</select>';
}

function sp_custom_profile_fields_output($out, $userid, $thisForm) {
	# see if we need to show any of our custom profile fields
	$cfields = sp_custom_profile_fields_get_data();
	if (!empty($cfields)) {
		# get the users profile data which will contain the custom profile data too
		global $spProfileUser;
		sp_SetupUserProfileData($userid);

		foreach ($cfields as $fields) {
			if ($fields['form'] ==  $thisForm) {
				# form match - display the custom profile field
				switch($fields['type'])
				{
					case 'checkbox':
						$out.= '<div class="spColumnSection spProfileLeftCol">';
						$out.= '<p class="spProfileLabel">'.$fields['name'].'</p>';
						$out.= '</div>';
						$out.= '<div class="spColumnSection spProfileSpacerCol"></div>';
						$out.= '<div class="spColumnSection spProfileRightCol">';
						$selected = (!empty($spProfileUser->$fields['slug']) && isset($spProfileUser->$fields['slug'])) ? ' checked="checked"' : '';
						$out.= '<label for="sf-'.esc_attr($fields['slug']).'"></label>';
						$out.= '<p class="spProfileLabel"><input type="checkbox"'.$selected.' name="'.esc_attr($fields['slug']).'" id="sf-'.esc_attr($fields['slug']).'"></p>';
						$out.= '</div>';
						break;

					case 'input':
						$out.= '<div class="spColumnSection spProfileLeftCol">';
						$out.= '<p class="spProfileLabel">'.$fields['name'].': </p>';
						$out.= '</div>';
						$out.= '<div class="spColumnSection spProfileSpacerCol"></div>';
						$out.= '<div class="spColumnSection spProfileRightCol">';
                        $text = (!empty($spProfileUser->$fields['slug'])) ? $spProfileUser->$fields['slug'] : '';
						$out.= '<p class="spProfileLabel"><input class="spControl" type="text" name="'.esc_attr($fields['slug']).'" value="'.esc_attr($text).'" /></p>';
						$out.= '</div>';
						break;

					case 'textarea':
						$out.= '<div class="spColumnSection spProfileLeftCol">';
						$out.= '<p class="spProfileLabel">'.$fields['name'].': </p>';
						$out.= '</div>';
						$out.= '<div class="spColumnSection spProfileSpacerCol"></div>';
						$out.= '<div class="spColumnSection spProfileRightCol">';
                        $text = (!empty($spProfileUser->$fields['slug'])) ? $spProfileUser->$fields['slug'] : '';
						$out.= '<p class="spProfileLabel"><textarea name="'.esc_attr($fields['slug']).'">'.sp_filter_text_edit($text).'</textarea></p>';
						$out.= '</div>';
						break;

					case 'select':
					case 'list':
						$out.= '<div class="spColumnSection spProfileLeftCol">';
						$out.= '<p class="spProfileLabel">'.$fields['name'].': </p>';
						$out.= '</div>';
						$out.= '<div class="spColumnSection spProfileSpacerCol"></div>';
						$out.= '<div class="spColumnSection spProfileRightCol">';
						$out.= '<p class="spProfileLabel">';

						if ($fields['type'] == 'select') {
							$out.= '<select class="spControl" name="'.esc_attr($fields['slug']).'" id="'.esc_attr($fields['slug']).'" >';
							if (empty($spProfileUser->$fields['slug'])) $out.= '<option value="" selected="selected">'.__('Choose one', 'cpf').'</option>';
						} else {
							$out.= '<select class="spControl" style="height:auto;" name="'.esc_attr($fields['slug']).'[]" id="'.esc_attr($fields['slug']).'" multiple="multiple" >';
							if (empty($spProfileUser->$fields['slug'])) $out.= '<option value="" selected="selected">'.__('Choose one or more', 'cpf').'</option>';
							$selList = array();
							if (!empty($spProfileUser->$fields['slug'])) $selList = $spProfileUser->$fields['slug'];
						}

						$list = explode(',', $fields['values']);
						if ($list) {
							foreach ($list as $option) {
								if ($fields['type'] == 'select') {
									$selected = (!empty($spProfileUser->$fields['slug']) && $spProfileUser->$fields['slug'] == $option) ? ' selected="selected"' : '';
								} else {
									$selected = (in_array(trim($option), $selList)) ? ' selected="selected"' : '';
								}
								$out.= '<option value="'.trim(esc_attr($option)).'"'.$selected.'>'.trim(esc_attr($option)).'</option>';
							}
						}
						$out.= '</p></select>';
						$out.= '</div>';
						break;

					case 'radio':
						$out.= '<div class="spColumnSection spProfileLeftCol">';
						$out.= '<p class="spProfileLabel">'.$fields['name'].': </p>';
						$out.= '</div>';
						$out.= '<div class="spColumnSection spProfileSpacerCol"></div>';
						$out.= '<div class="spColumnSection spProfileRightCol">';
						$list = explode(',', $fields['values']);
						if ($list) {
							foreach ($list as $x => $option) {
								$check = ($spProfileUser->$fields['slug'] == trim($option)) ? ' checked="checked"' : '';
								$out.= '<label for="sf-'.esc_attr($fields['slug']).$x.'">'.trim(esc_attr($option)).'</label>';
								$out.= '<p class="spProfileLabel"><input class="spControl" type="radio" name="'.esc_attr($fields['slug']).'" id="sf-'.esc_attr($fields['slug']).$x.'" value="'.trim(esc_attr($option)).'"'.$check.' /></p>';
								$out.= '<br />';
							}
						}
						$out.= '</div>';
						break;
				}
			}
		}
	}

	return $out;
}

function sp_custom_profile_fields_save($userid, $thisForm) {
	# see if we need to save any of our custom profile fields
	$cfields = sp_custom_profile_fields_get_data();
	if (!empty($cfields)) {
		foreach ($cfields as $fields) {
			if ($fields['form'] ==  $thisForm) {
				if ($fields['type'] == 'textarea') {
					update_user_meta($userid, $fields['slug'], sp_filter_text_save($_POST[$fields['slug']]));
				} elseif ($fields['type'] == 'list') {
					update_user_meta($userid, $fields['slug'], $_POST[$fields['slug']]);
				} else {
					update_user_meta($userid, $fields['slug'], sp_filter_title_save(trim($_POST[$fields['slug']])));
				}
			}
		}
	}
}
?>