<?php
/*
Simple:Press Plugin Title: Custom Profile Fields
Version: 1.2.3
Plugin URI: http://simple-press.com
Description: A Simple:Press plugin for creating custom profile fields
Author: Andy Staines & Steve Klasen
Author URI: http://simple-press.com
Simple:Press Versions: 5.2.3 and above
$LastChangedDate: 2013-08-05 13:11:56 -0700 (Mon, 05 Aug 2013) $
$Rev: 10470 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

define('CPFDIR', 		SFPLUGINDIR.'custom-profile-fields/');
define('CPFADMINDIR', 	SFPLUGINDIR.'custom-profile-fields/admin/');
define('CPFAHAHDIR', 	SFPLUGINDIR.'custom-profile-fields/ahah/');
define('CPFLIBDIR', 	SFPLUGINDIR.'custom-profile-fields/library/');
define('CPFTAGSDIR', 	SFPLUGINDIR.'custom-profile-fields/template-tags/');
define('CPFSCRIPT', 	SFPLUGINURL.'custom-profile-fields/resources/jscript/');

add_action('sph_admin_menu', 															'sp_custom_profile_fields_menu');
add_action('init', 																		'sp_custom_profile_fields_localization');
add_action('sph_ahah_handler_cpf',														'sp_custom_profile_fields_ahah');
add_action('sph_activate_custom-profile-fields/sp-custom-profile-fields-plugin.php', 	'sp_custom_profile_fields_install');
add_action('sph_uninstall_custom-profile-fields/sp-custom-profile-fields-plugin.php',	'sp_custom_profile_fields_uninstall');
add_action('sph_UpdateProfile', 														'sp_custom_profile_fields_submit', 10, 2);

add_filter('sph_admin_help-admin-profiles',		'sp_custom_profile_fields_help', 10, 3);
add_filter('sph_plugins_active_buttons', 		'sp_custom_profile_fields_uninstall_option', 10, 2);
add_filter('sph_ProfileFormBottom', 			'sp_custom_profile_fields_show', 10, 3);
add_filter('sph_user_class_meta', 			    'sp_custom_profile_load_meta');

function sp_custom_profile_fields_menu() {
    $subpanels = array(
                __('Profile Custom Fields', 'cpf') => array('admin' => 'sp_custom_profile_fields_admin', 'save' => 'sp_custom_profile_fields_update', 'form' => 1, 'id' => 'spcpf')
                            );
    sp_add_admin_subpanel('profiles', $subpanels);
}

function sp_custom_profile_fields_admin() {
    include_once(CPFLIBDIR.'sp-custom-profile-fields-components.php');
    include_once(CPFADMINDIR.'sp-custom-profile-fields-admin.php');
	sp_custom_profile_fields_admin_form();
}

function sp_custom_profile_fields_update() {
    include_once(CPFLIBDIR.'sp-custom-profile-fields-components.php');
    include_once(CPFADMINDIR.'sp-custom-profile-fields-admin-save.php');
	return sp_custom_profile_fields_admin_save();
}

function sp_custom_profile_fields_help($file, $tag, $lang) {
    if ($tag == '[custom-fields]') $file = CPFADMINDIR.'sp-custom-profile-fields-admin-help.'.$lang;
    return $file;
}

function sp_custom_profile_fields_localization() {
	sp_plugin_localisation('cpf');
}

function sp_custom_profile_fields_ahah() {
    include_once(CPFLIBDIR.'sp-custom-profile-fields-components.php');
    include_once(CPFAHAHDIR.'sp-custom-profile-fields-ahah.php');
}

function sp_custom_profile_fields_install() {
    include_once(CPFDIR.'sp-custom-profile-fields-install.php');
    sp_custom_profile_fields_do_install();
}

function sp_custom_profile_fields_uninstall() {
    include_once(CPFDIR.'sp-custom-profile-fields-uninstall.php');
    sp_custom_profile_fields_do_uninstall();
}

function sp_custom_profile_fields_uninstall_option($actionlink, $plugin) {
    include_once(CPFLIBDIR.'sp-custom-profile-fields-components.php');
    $actionlink = sp_custom_profile_uninstall_option_links($actionlink, $plugin);
	return $actionlink;
}

function sp_custom_profile_fields_show($out, $userid, $thisForm) {
    include_once(CPFLIBDIR.'sp-custom-profile-fields-components.php');
	return sp_custom_profile_fields_output($out, $userid, $thisForm);
}

function sp_custom_profile_fields_submit($userid, $thisForm) {
    include_once(CPFLIBDIR.'sp-custom-profile-fields-components.php');
	sp_custom_profile_fields_save($userid, $thisForm);
}

function sp_custom_profile_load_meta($list) {
    include_once(CPFLIBDIR.'sp-custom-profile-fields-components.php');
	$list = sp_custom_profile_do_load_meta($list);
    return $list;
}

# Define Template Tags globally available (dont have to be enabled on template tag panel)
function sp_CustomProfileFieldsDisplay($name, $userid=0) {
	include_once(CPFLIBDIR.'sp-custom-profile-fields-components.php');
    include_once(CPFTAGSDIR.'sp-custom-profile-fields-display-tag.php');
    sp_do_CustomProfileFieldsDisplay($name, $userid);
}

function sp_CustomProfileFieldsDisplayExtended($args, $name, $userid=0, $label='') {
	include_once(CPFLIBDIR.'sp-custom-profile-fields-components.php');
    include_once(CPFTAGSDIR.'sp-custom-profile-fields-display-tag.php');
    sp_do_CustomProfileFieldsDisplayExtended($args, $name, $userid, $label);
}

?>