<?php
/*
$LastChangedDate: 2013-04-18 22:21:03 -0700 (Thu, 18 Apr 2013) $
$Rev: 10187 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_do_CustomProfileFieldsDisplay($name, $userid=0) {
    #check if forum displayed
    if (sp_abort_display_forum()) return;

    $cfields = sp_custom_profile_fields_get_data();
    if (!empty($cfields)) {
    	foreach ($cfields as $fields) {
    		if ($fields['name'] ==  $name) {
                # grab the data
    			if (empty($userid)) {
    				global $spThisUser;
    				echo $spThisUser->$fields['slug']; # user class handles filtering
    			} else {
    				$data = get_user_meta($userid, $fields['slug'], true);

                    # now fitler based on type and output the data
            		if ($fields['type'] == 'textarea') {
                        echo sp_filter_text_display($data);
                    } else {
                        echo sp_filter_title_display($data);
                    }
    			}
    		}
    	}
    }
}

/* 	============================================================================================
	sp_CustomProfileFieldsDisplayExtended

	displays a custom profile field

	added: version 1.2.0

	parameters:
		name			description								type			default
		----------------------------------------------------------------------------------------
		tagClass		class to be applied for styling			text			spCustomField
		type			container type - 'div' or 'span'		text			'div'
		labelClass		class to be applied to optional label	text			spCustomLabel
		labelSep		text to be used between label and data	text			': '
		before			text to display before data				text			''
		after			text to display after the data			text			''
		listSep			text to display between each item (list)text			', '
		echo			echo content or return content			true/false		true


	NOTES:	True must be expressed as a 1 and False as a zero
			All text items can include allowed html

==============================================================================================*/
function sp_do_CustomProfileFieldsDisplayExtended($args, $name, $userid=0, $label=00) {
    #check if forum displayed
    if (sp_abort_display_forum()) return;

    $cfields = sp_custom_profile_fields_get_data();
    if (empty($cfields) || empty($name)) return;

	$defs = array('tagClass'	=> 'spCustomField',
				  'type'		=> 'div',
				  'labelClass'	=> 'spCustomLabel',
				  'labelSep'	=> ': ',
				  'before'		=> '',
				  'after'		=> '',
				  'listSep'		=> ', ',
				  'echo'		=> 1
				  );
	$a = wp_parse_args($args, $defs);
	extract($a, EXTR_SKIP);

	# sanitize before use
	$tagClass	= esc_attr($tagClass);
	$type		= esc_attr($type);
	$labelClass	= esc_attr($labelClass);
	$before		= esc_attr($before);
	$after		= esc_attr($after);
	$listSep	= esc_attr($listSep);
	$echo		= (int) $echo;
	$out		= '';

	foreach ($cfields as $fields) {
		if ($fields['name'] ==  $name) {
			# grab the data
			if (empty($userid)) {
				global $spThisUser;
				$cfData = $spThisUser->$fields['slug']; # user class handles filtering
			} else {
				$cfData = get_user_meta($userid, $fields['slug'], true);
				# now fitler based on type and output the data
				if ($fields['type'] == 'textarea') {
					$cfData = sp_filter_text_display($cfData);
				} elseif ($fields['type'] != 'list') {
					$cfData = sp_filter_title_display($cfData);
				}
			}
			$cfType = $fields['type'];
			break;
		}
	}
	if(!empty($cfData)) {
		$out.= "<$type class='$tagClass'>$before";
		if(!empty($label)) {
			$out.= "<span class='$labelClass'>$label$labelSep</span>";
		}
		if($cfType == 'list') {
			$first = true;
			foreach($cfData as $item) {
				if(!$first) $out.= $listSep;
				$out.= $item;
				$first = false;
			}
		} else {
			$out.= $cfData;
		}
		$out.= "$after</$type>";
	}

	if ($echo) {
		echo $out;
	} else {
		return $out;
	}
}

?>